package jp.gr.javacons.industry.seminar.remotetempmonitor;

import java.util.Vector;
import java.io.Serializable;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.RemoteException;
import jp.gr.javacons.industry.seminar.tempmonitor.DataCollector;

public class DataCollectorDelegator extends UnicastRemoteObject
				implements RemoteDataCollector, Serializable {

    protected transient DataCollector collector;

    public DataCollectorDelegator(DataCollector collector)
                                             throws RemoteException {
        super();
        this.collector = collector;
    }

    public int getChannelSize(){
	return collector.getChannelSize();
    }

    public int getMinimumValue(){
	return collector.getMinimumValue();
    }

    public int getMaximumValue(){
	return collector.getMaximumValue();
    }

    public Vector getData(){
	return collector.getData();
    }
}
